=== debian/changelog ===
lammps (0~20180510.gitaa1d815fe-4ubuntu1) cosmic; urgency=medium

  * Don't run the autopkg tests on armhf.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Jun 2018 12:54:23 +0200

lammps (0~20180510.gitaa1d815fe-4) unstable; urgency=medium

  * [3958d4e]  Disable mpi-unit-test on armhf and armel

 -- Anton Gladky <gladk@debian.org>  Tue, 15 May 2018 18:24:32 +0200

lammps (0~20180510.gitaa1d815fe-3) unstable; urgency=medium

  * [1f3a539] Disable mpi-unit-test on i386

 -- Anton Gladky <gladk@debian.org>  Sun, 13 May 2018 15:18:25 +0200

lammps (0~20180510.gitaa1d815fe-2) unstable; urgency=medium

  * [dfd9a8b] Fix FTBFS on most platforms. (Closes: #896860)

 -- Anton Gladky <gladk@debian.org>  Sun, 13 May 2018 10:09:09 +0200

lammps (0~20180510.gitaa1d815fe-1) unstable; urgency=medium

  [ Adrian Bunk ]
  * [6692458] Fix FTBFS with TeX Live 2018

  [ Anton Gladky ]
  * [88573f8] New upstream version 0~20180510.gitaa1d815fe
  * [452d2b9] Set compat-level 11
  * [859ce26] Set Standards-Version to 4.1.4
  * [569ae1d] Add htmldoc to build-depends
  * [b1acdc8], [a8f70a1]  Refresh patch
  * [cc843f9] Update paths in d/rules and in doc-base
  * [189066e] Remove deprecated autopkgtest field in d/control

 -- Anton Gladky <gladk@debian.org>  Sat, 12 May 2018 21:05:20 +0200
